{$O+,F+}
unit panels;
interface
uses crt, dos, pallete, {submain,{} pczx;
const
     noPanel=0;
     pcPanel=1; trdPanel=2; fdiPanel=3; tapPanel=4;
     infPanel=11;
type
    pcdirrec=
         record
          fname:string[8];
          fext:string[3];
          flength:longint;
          mark:boolean;
          fdt:datetime;
          fattr:word;
          itdir:byte;
         end;
    pcinsedrec=
         record
          crc16:word;
         end;
    pcinsedp=array[1..1] of pcinsedrec;

    pcdirp=array[1..1] of pcdirrec;
    trddirrec=
         record
          name:string[8];
          typ:char;
          start:word;
          length:word;
          totalsec:byte;
          n1sec:byte;
          n1tr:byte;
          mark:boolean;
         end;
    trddirp=array[1..1] of trddirrec;
    trddiskrec=
         record
          n1FreeSec:byte;
          nTr1FreeSec:byte;
          DiskTyp:byte;
          files:byte;
          free:word;
          trdosCode:byte;
          delfiles:byte;
          diskLabel:string[8];
         end;
    trdinsedrec=
         record
          crc16:word;
         end;
    trdinsedp=array[1..1] of trdinsedrec;


type
     PPanel=^TPanel;
     TPanel=
      object
       pcdir                    :^pcdirp;
       pcins                    :^pcinsedp;
       pctdirs,pctfiles         :integer;
       oldpctdirs,oldpctfiles   :integer;
       pcnd                     :pathstr;
       pcnn                     :string[12];
       infoline,selinfoline,
       freeline                 :string[39];
       bkinfoline,txtinfoline   :byte;
       bknselinfoline,txtnselinfoline,
       bksselinfoline,txtsselinfoline,
       bknfreeline,txtnfreeline,
       bksfreeline,txtsfreeline :byte;
       xinfoline,yinfoline,
       xselinfoline,yselinfoline,
       xfreeline,yfreeline      :byte;

       pcinsed,trdinsed         :word;

       mayselinfoline,
       mayfreeline              :boolean;

       trdnn                    :string[10];

       pcf,pcfrom               :integer;
       trdfrom,trdf,fdifrom,fdif,
       tapfrom,tapf,
       flopfrom,flopf           :integer;
       treec                    :byte;
       PanelType, SortType      :byte;
       clLastPanelType,
       LastPanelType            :byte;
       PanelLong, PanelHi       :integer;
       PosX, PosY               :byte;
       InfoLines                :byte;
       PutFrom,dList            :byte;
       NameLine                 :boolean;
       Visible                  :boolean;

       trddir                   :^trddirp;
       trdins                   :^trdinsedp;
       trdtfiles                :byte;
       trddisk                  :trddiskrec;
       trdfile                  :comstr;

       procedure Build;
       procedure Hide;
       procedure pcAdd(r:pcdirrec; isitdir:boolean; ind:integer);
{       procedure pcDel(ndx:integer);{}
       procedure pcMDF(path:pathstr);
       procedure pcPDF(fr:integer);
       procedure pcInside;
       procedure TrueCur;
       procedure trdInside;

       procedure gettrdinfo(path:pathstr);

       procedure trdMDF(path:pathstr);
       procedure trdPDF(fr:integer);

       procedure PanelSetup;

       function  TRDOSe3(i:integer):string;
       function  TRDOSe31(i:integer):string;

       function  trdTracks(name:string):byte;
      end;

var
     rp,lp:TPanel;



implementation
uses memory,{pc,{}main,sorting, rv;
var itemp:integer;


procedure TPanel.PanelSetup;
begin
 rp.panellong:=gmaxy-6;
 if not cmdlined then inc(rp.panellong);
 rp.panelhi:=rp.panellong-rp.InfoLines;
 if rp.nameline then
  begin
   rp.putfrom:=3;
   rp.dlist:=0;
  end
 else
  begin
   rp.putfrom:=2;
   rp.dlist:=1;
   inc(rp.panelhi);
  end;

 lp.panellong:=gmaxy-6;
 if not cmdlined then inc(lp.panellong);
 lp.panelhi:=lp.panellong-lp.InfoLines;
 if lp.nameline then
  begin
   lp.putfrom:=3;
   lp.dlist:=0;
  end
 else
  begin
   lp.putfrom:=2;
   lp.dlist:=1;
   inc(lp.panelhi);
  end;
end;


procedure TPanel.TrueCur;
var fnd:boolean; st:string; i:integer;
begin
fnd:=false;
 case panelType of

  pcPanel:
   begin
    for i:=1 to pctdirs+pctfiles do
     begin
      st:=strlo(nospace(pcdir^[i].fname+'.'+pcdir^[i].fext));
      if st[length(st)]='.' then delete (st,length(st),1);
      if st=strlo(nospace(pcnn)) then begin fnd:=true; break; end;
     end;

    if fnd then
     begin
      pcf:=1; pcfrom:=1;
      while pcfrom+pcf-1<i do
       begin
        inc(pcf);
        if pcf>panelhi*3 then begin pcf:=panelhi*3; inc(pcfrom); end;
       end;
     end;

    while pcfrom+pcf-1 > pctdirs+pctfiles do
     begin
      dec(pcfrom);
      if pcfrom<1 then begin pcfrom:=1; dec(pcf); end;
     end;
    if pcf<1 then pcf:=1;
   end;

  trdPanel:
   begin
    if trdfrom+trdf-1<>1 then
     begin
      for i:=1 to trdtfiles do
       begin
        st:=trddir^[i].name+'.'+trddir^[i].typ;
        if st=trdnn then begin fnd:=true; break; end;
       end;

      if fnd then
       begin
        trdf:=1; trdfrom:=1;
        while trdfrom+trdf-1<i do
         begin
          inc(trdf);
          if trdf>panelhi*3 then begin trdf:=panelhi*3; inc(trdfrom); end;
         end;
       end;

      while trdfrom+trdf-1 > trdtfiles do
       begin
        dec(trdfrom);
        if trdfrom<1 then begin trdfrom:=1; dec(trdf); end;
       end;
      if trdf<1 then trdf:=1;
     end;
   end;

 end;
end;


procedure TPanel.pcInside;
begin
dirs:=pctdirs; files:=pctfiles;
f:=pcf; from:=pcfrom; phi:=panelhi;
end;


procedure TPanel.trdInside;
begin
dirs:=0; files:=trdtfiles;
f:=trdf; from:=trdfrom; phi:=panelhi;
end;


procedure TPanel.Build;
var a:byte; s:string;
begin
PanelSetup;
{if not(paneltype in[1..10]) then exit;{}
s:='ͻ';
if (posx<>1)and clocked then s:='';
cmprint(BkRama,TxtRama,posx,posy, s);
cmprint(BkRama,TxtRama,posx,posy+1, '                                    ');
for a:=3 to panellong+2+(1-InfoLines)-1 do
cmprint(BkRama,TxtRama,posx,posy+a-1, '                                    ');
for a:=panellong+2+(1-InfoLines)+1 to panellong+3 do
cmprint(BkRama,TxtRama,posx,posy+a-1,'                                      ');
cmprint(BkRama,TxtRama,posx,panellong+4,'ͼ');
cmprint(BkRama,TxtRama,posx,panellong+2+(1-InfoLines),
        'ĺ');
cmprint(BkRama,TxtRama,posx,panellong+3,'                                      ');
if nameline then
 begin
  if lang=rus then s:='         '
              else s:='    Name    ';
  cmprint(BkNameLine,TxtNameLine,posx+1,posy+1,s);
  cmprint(BkNameLine,TxtNameLine,posx+1+13,posy+1,s);
  cmprint(BkNameLine,TxtNameLine,posx+1+13+13,posy+1,s);
 end;
visible:=true;
{if rMoused then MouseShow;{}
end;

procedure TPanel.Hide;
var
   ix,iy,i:word;
 begin
  i:=posx*2-1;
  for iy:=0 to gmaxy-3 do
   begin
    for ix:=posx-1 to posx+40-2 do
     begin
      mem[$B800:((80*iy)+ix)*2]:=SavedDeskTop^[i];   inc(i);
      mem[$B800:((80*iy)+ix)*2+1]:=SavedDeskTop^[i]; inc(i);
     end;
    inc(i,80);
   end;
  visible:=false;
{if rMoused then MouseShow;{}
 end;



procedure TPanel.pcAdd(r:pcdirrec; isitdir:boolean; ind:integer);
var
   m:integer;
begin
pcdir^[ind].fname  :=r.fname;
pcdir^[ind].fext   :=r.fext;
pcdir^[ind].fdt    :=r.fdt;
pcdir^[ind].fattr  :=r.fattr;
pcdir^[ind].mark   :=false;
if isitdir then
 begin
  pcdir^[ind].flength:=-1;
  pcdir^[ind].itdir  :=1;
 end
else
 begin
  pcdir^[ind].flength:=r.flength;
  pcdir^[ind].itdir  :=0;
 end;
end;


{
procedure TPanel.pcDel(ndx:integer);
var
   m:integer;
begin
for m:=ndx to pctdirs+pctfiles do
 begin
  pcdir^[m].fname  :=pcdir^[m+1].fname;
  pcdir^[m].fext   :=pcdir^[m+1].fext;
  pcdir^[m].fdt    :=pcdir^[m+1].fdt;
  pcdir^[m].flength:=pcdir^[m+1].flength;
  pcdir^[m].fattr  :=pcdir^[m+1].fattr;
  pcdir^[m].mark   :=pcdir^[m+1].mark;
  pcdir^[m].itdir  :=pcdir^[m+1].itdir;
 end;
end;
{}

procedure TPanel.pcMDF(path:pathstr);
var
   rec:searchrec;
   dt:datetime;
   strtemp:string;
   fattrm,ie,i,m,j,readed:integer;
   fa:file;
   fnew:pcdirrec;

begin
j:=0;
for i:=1 to pctdirs+pctfiles do if pcdir^[i].mark then
 begin
  inc(j);
  pcins^[j].crc16:=crc16(pcdir^[i].fname+'.'+pcdir^[i].fext);
 end;
pcinsed:=j;

path:=nospace(path);
path:=checkpath(path);{}
if (path[length(path)]='\')and(length(path)>3){} then delete(path,length(path),1);
chdir(Path);
pcnd:=curentdir; if pcnd[length(pcnd)]<>'\' then pcnd:=pcnd+'\';
treec:=length(pcnd)-length(without(pcnd,'\'));
oldpctdirs:=pctdirs; oldpctfiles:=pctfiles;

pctdirs:=0; pctfiles:=0;{}

findfirst('*.*',$3F,rec);
while doserror=0 do
 begin
  if (rec.name='.') then findnext(rec);{}
  unpacktime(rec.time,dt);
  fnew.fname:=getof(rec.name,_name);
  fnew.fext:=copy(getof(rec.name,_ext),2,3);
  if rec.name='..' then begin fnew.fname:='..'; fnew.fext:=''; end;
  fnew.fext:=fnew.fext+space(3-length(fnew.fext));
  fnew.flength:=rec.size;
  fnew.fdt:=dt;
  fnew.fattr:=rec.attr;

  if (rec.attr and directory = directory) then
   begin
      inc(pctdirs);
      pcAdd(fnew,true,pctdirs+pctfiles);
   end;

  if (rec.attr and (directory or volumeid)=0) then
   begin
      inc(pctfiles);
      pcAdd(fnew,false,pctdirs+pctfiles);
   end;

  if pctdirs+pctfiles>(max-10) then
   begin
    if lang=rus then errormessage('誮  䠩') else errormessage('More than 1900 files');
    break;
   end;
  findnext(rec);
 end;

for i:=pctdirs+pctfiles+1 to pctdirs+pctfiles+panelhi*3 do
 begin
  pcdir^[i].fname:='        ';
  pcdir^[i].fext:='   ';
 end;

globalsort;{}

for j:=1 to pctdirs+pctfiles do pcdir^[j].mark:=false;

for i:=1 to pcinsed do for j:=1 to pctdirs+pctfiles do
 begin
  if pcins^[i].crc16=crc16(pcdir^[j].fname+'.'+pcdir^[j].fext) then pcdir^[j].mark:=true;
 end;
end;








procedure TPanel.pcPDF(fr:integer);
var px,py,py0,ph,paper,ink,pp,ii,iii:byte;
    i,n:integer;
    name:string; e:string[3];
begin
if paneltype<>pcPanel then exit;
n:=pctdirs+pctfiles;
px:=posx+1; py:=putfrom;
if n>fr-1+panelhi*3 then n:=fr-1+panelhi*3;
for i:=fr to n do
 begin
  name:=pcDir^[i].fname;
  name:=name+space(8-length(name))+' '+pcDir^[i].fext;
  if i>pctdirs then name:=strlo(name);
  paper:=bkNT; ink:=txtNT;
  if i<=pctdirs then begin paper:=bkDir; ink:=txtDir; ii:=ink; end
  else
   begin
    e:=nospace(copy(name,10,3)); if e='' then e:='.';
    col(e,pcDir^[i].flength,paper,ink);
    pp:=paper; ii:=ink; iii:=ink;
   end;
  if pcdir^[i].mark then begin paper:=bkST; ink:=txtST; end;

  if focus=left then
   begin
    if (i=from+f-1)and(px<40) then begin paper:=bkCurNT; ink:=txtCurNT; end;
    if (i=from+f-1)and(px<40)and(pcdir^[i].mark) then begin paper:=bkCurST; ink:=txtCurST; end;
   end
  else
   begin
    if (i=from+f-1)and(px>40) then begin paper:=bkCurNT; ink:=txtCurNT; end;
    if (i=from+f-1)and(px>40)and(pcdir^[i].mark) then begin paper:=bkCurST; ink:=txtCurST; end;
   end;
  if ((pcdir^[i].fattr and SysFile) <> 0) then name[1]:=upcase(name[1]);
  cmprint(paper,ink,px,py,name);
  if ii=paper then ii:=ink;
  if (focus=left)and(i=from+f-1)and(px<40) then ii:=txtCurNT;
  if (focus=right)and(i=from+f-1)and(px>40) then ii:=txtCurNT;
  if (focus=left)and(i=from+f-1)and(px<40)and(pcdir^[i].mark) then ii:=iii;
  if (focus=right)and(i=from+f-1)and(px>40)and(pcdir^[i].mark) then ii:=iii;
  if ((pcdir^[i].fattr and ReadOnly) <> 0) then cmprint(paper,ii,px+8,py,#$B0);
  if ((pcdir^[i].fattr and Hidden) <> 0) then cmprint(paper,ii,px+8,py,#$B1);
  if ((pcdir^[i].fattr and SysFile) <> 0) then cmprint(paper,ii,px+8,py,#$B2);
  if pcdir^[i].mark then cmprint(paper,ii,px+8,py,#251);
  inc(py);
  if py>panelhi+putfrom-1 then begin py:=putfrom; inc(px,13); end;
 end;

for i:=n+1 to panelhi*3 do
 begin
  name:=space(12);
  cmprint(bkNT,txtNT,px,py,name);
  inc(py);
  if py>panelhi+putfrom-1 then begin py:=putfrom; inc(px,13); end;
 end;

end;




procedure TPanel.trdMDF(path:pathstr);
var
    fb:file of byte;
    i,k:integer;
    buf:array[1..16] of byte;
    s:string[8];
    b:byte;
begin
if checkdirfile(path)<>0 then
 begin
  if lang=rus then
  errormessage('H  䠩 "'+getof(path,_name)+getof(path,_ext)+'"')
  else errormessage('File "'+getof(path,_name)+getof(path,_ext)+'" not found');
  paneltype:=pcpanel;
  pcMDF(pcnd);
  pcinside;
  truecur;
  pcPDF(pcfrom);
  pcinfo; putcmdline;
  pcdirinfo; pcselinfo;
  exit;
 end;
{$I-}
filemode:=0;
assign(fb,path); reset(fb);
seek(fb,$8e4); read(fb,trdtfiles); inc(trdtfiles);
trddir^[1].name:='<<      ';
trddir^[1].typ:='-';
trddir^[1].start:=0;
trddir^[1].length:=0;
trddir^[1].totalsec:=0;
trddir^[1].n1sec:=0;
trddir^[1].n1tr:=0;
trddir^[1].mark:=false;

for i:=1 to trdtfiles do
 begin
  seek(fb,16*(i-1));
  for k:=0 to 15 do read(fb,buf[k+1]);
  s:='';
  for k:=1 to 8 do s:=s+chr(buf[k]);
  trddir^[i+1].name:=s;
  trddir^[i+1].typ:=chr(buf[9]);
  trddir^[i+1].start:=buf[10]+256*buf[11];
  trddir^[i+1].length:=buf[12]+256*buf[13];
  trddir^[i+1].totalsec:=buf[14];
  trddir^[i+1].n1sec:=buf[15];
  trddir^[i+1].n1tr:=buf[16];
  trddir^[i+1].mark:=false;
 end;

close(fb);
trdfile:=path;
{$I+}
end;



procedure TPanel.trdPDF(fr:integer);
var px,py,py0,ph,paper,ink,pp,ii:byte;
    i,n:integer;
    name:string; e:string[3];
begin
if paneltype<>trdPanel then exit;
n:=trdtfiles;

px:=posx+1; py:=putfrom;
if n>fr-1+panelhi*3 then n:=fr-1+panelhi*3;
for i:=fr to n do
 begin
  name:=trdDir^[i].name;
  if i=1 then name:=name+space(12-length(name)) else
   begin
    name:=name+space(8-length(name))+' '+TRDOSe3(i);
   end;
{  if i>pctdirs then name:=strlo(name);{}
  paper:=bkNT; ink:=txtNT;

    e:='<'+trdDir^[i].typ+'>';
    col(e,trdDir^[i].length,paper,ink);
    if (ord(trdDir^[i].name[1])=1)or(ord(trdDir^[i].name[1])=0) then begin paper:=bkg4; ink:=txtg4; end;
    if i=1 then begin paper:=bkdir; ink:=txtdir; end;
    pp:=paper; ii:=ink;

  if trddir^[i].mark then begin paper:=bkST; ink:=txtST; end;

  if focus=left then
   begin
    if (i=from+f-1)and(px<40) then begin paper:=bkCurNT; ink:=txtCurNT; end;
    if (i=from+f-1)and(px<40)and(trddir^[i].mark) then begin paper:=bkCurST; ink:=txtCurST; end;
   end
  else
   begin
    if (i=from+f-1)and(px>40) then begin paper:=bkCurNT; ink:=txtCurNT; end;
    if (i=from+f-1)and(px>40)and(trddir^[i].mark) then begin paper:=bkCurST; ink:=txtCurST; end;
   end;
  {
  if (i=from+f-1) then begin paper:=bkCurNT; ink:=txtCurNT; end;
  if (i=from+f-1)and(pcdir^[i].mark) then begin paper:=bkCurST; ink:=txtCurST; end;
{}
  cmprint(paper,ink,px,py,name);
  if trddir^[i].mark then cmprint(paper,ii,px+8,py,#251);
  inc(py);
  if py>panelhi+putfrom-1 then begin py:=putfrom; inc(px,13); end;
 end;

{pcdirinfo; pcselinfo;{}

for i:=n+1 to panelhi*3 do
 begin
  name:=space(12);
  cmprint(bkNT,txtNT,px,py,name);
  inc(py);
  if py>panelhi+putfrom-1 then begin py:=putfrom; inc(px,13); end;
 end;
{if rMoused then MouseShow;{}
end;




procedure TPanel.GetTRDInfo(path:pathstr);
var
     fb:file of byte;
     b,b2:byte;
     i:integer;
     stemp:string;
begin
{$I-}
filemode:=0;
assign(fb,path); reset(fb);

seek(fb,$8e1); read(fb,b); trddisk.n1freesec:=b;
seek(fb,$8e2); read(fb,b); trddisk.ntr1freesec:=b;
seek(fb,$8e3); read(fb,b); trddisk.disktyp:=b;
seek(fb,$8e4); read(fb,b); trddisk.files:=b;
seek(fb,$8e5); read(fb,b); read(fb,b2); trddisk.free:=b+256*b2;
seek(fb,$8e7); read(fb,b); trddisk.trdoscode:=b;
seek(fb,$8f4); read(fb,b); trddisk.delfiles:=b;
seek(fb,$8f5); stemp:=''; for i:=1 to 8 do begin read(fb,b); stemp:=stemp+chr(b); end;
trddisk.disklabel:=stemp;
close(fb);
{$I+}
i:=ioresult;
end;




function TPanel.TRDOSe3(i:integer):string;
var name:string;
begin
if TRDOS3 then
 name:=trdDir^[i].typ+chr(lo(trdDir^[i].start))+chr(hi(trdDir^[i].start))
          else
 name:='<'+trdDir^[i].typ+'>';
if trdDir^[i].typ='B' then name:='<'+trdDir^[i].typ+'>';
TRDOSe3:=name;
end;


function TPanel.TRDOSe31(i:integer):string;
var name:string;
begin
if TRDOS3 then
 name:=trdDir^[i].typ+chr(lo(trdDir^[i].start))+chr(hi(trdDir^[i].start))
          else
 name:=trdDir^[i].typ;
if trdDir^[i].typ='B' then name:=trdDir^[i].typ;
TRDOSe31:=name;
end;


function TPanel.trdTracks(name:string):byte;
var i:byte;
begin
i:=filelen(name)div 8192;
trdTracks:=i;
end;





begin
lp.PanelType:=pcPanel; rp.PanelType:=pcPanel;
lp.posx:=1;  lp.posy:=1;
rp.posx:=41; rp.posy:=1;
lp.panellong:=gmaxy-6; rp.panellong:=gmaxy-6;
lp.infolines:=2; rp.infolines:=2;
lp.nameline:=true; rp.nameline:=true;
lp.visible:=true; rp.visible:=true;
lp.pcf:=1; rp.pcf:=1; lp.pcfrom:=1; rp.pcfrom:=1;
lp.trdfrom:=1; lp.trdf:=1; lp.fdifrom:=1; lp.fdif:=1; lp.tapfrom:=1; lp.tapf:=1;
rp.trdfrom:=1; rp.trdf:=1; rp.fdifrom:=1; rp.fdif:=1; rp.tapfrom:=1; rp.tapf:=1;
end.